<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 34.40</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <div class="text-center mt-3 mb-3">
      <h2>F100 - Quản trị người dùng</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <label class="col-sm-2 col-form-label" for="firstNameInput">First name</label>
        <div class="col-sm-3">
          <input type="text" id="firstNameInput" class="form-control" placeholder="Nhap first name ...">
        </div>
        <label class="col-sm-2 col-form-label" for="lastNameInput">Last name</label>
        <div class="col-sm-3">
          <input type="text" id="lastNameInput" class="form-control" placeholder="Nhap last name ...">
        </div>
        <div class="col-sm-2">
          <button id="btn-filter-user" class="btn btn-success" id="btn-filter">Filter user</button>
        </div>
      </div>
    </div>
  </div>

  <div class="container mt-2">
    <div class="row">
      <div class="col-12 text-nowrap">
        <table id="table-users" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Mã người dùng</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>

          </tbody>
        </table>
      </div>
    </div>
  </div>
</body>
​
<script>
  "use strict";
  const gCOL_USERID = 0;
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gUsersArr = [];

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $("#btn-filter-user").click(onButtonFilter)


  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  /**
   * Call API để get all users và lưu vào mảng toàn cục gUsersArr.
   * gUsersArr được sử dụng cho mục đích filter về sau
  */
  // Hàm thực thi khi load trang
  function onPageLoading() {
    // gọi api load dữ liệu users
    $.ajax({
      url: 'http://203.171.20.210:8080/devcamp-register-java-api/users',
      type: 'GET',
      async: false,
      dataType: 'json',
      success: function (paramObjectUser) {
        gUsersArr = paramObjectUser;
      }
    });
    // gọi hàm để load dữ liệu mảng users vào table
    fillDataTableUser(gUsersArr);
  }
  // khai báo hàm nút filter 
  function onButtonFilter() {
    console.log("Đã ấn nút filter");
    // b1 thu thập dữ liệu . 
    var vObjectUser = {
      firstName: "",
      lastName: ""
    }
    getCollectData(vObjectUser);
    // bước 2 kiểm tra dữ liệu bỏ qua
    // bước 3 tìm kiếm ( tìm kiếm xem có dữ liệu phù hợp trong bảng không );
    var vResult =  getFindUser(vObjectUser);
    // hiển thị dữ liệu 
    console.log(vObjectUser);
    console.log(gUsersArr);
    console.log(vResult);
  }
  // khai báo nút chi tiết 
  function onChiTiet(){
    console.log(" đã ấn nút chi tiêt");
    console.log(this);
    var vRow = $(this).closest("tr"); // hàng chưas id người dùng 
    var vIdText = vRow.find("td:eq(" + gCOL_USERID +  ")").text();
    console.log(vIdText);
    alert("id người dùng là : " + vIdText);

  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //  hàm thu thập dữ liệu 
  function getCollectData(paramObject) {
    console.log("thu thap du lieu");
    paramObject.firstName = $("#firstNameInput").val().trim();
    paramObject.lastName = $("#lastNameInput").val().trim();
  }
  // hàm tìm kiếm 
  function getFindUser(paramObject) {
    "use strict"
    var vUserNew = [];
    console.log(" ham tim kiem user ");
    // nếu first name hoạc last name được nhập 
    if (paramObject.firstName != "" || paramObject.lastName != "") {
      for (var bI = 0; bI < gUsersArr.length; bI++) {
        const bUserObject = gUsersArr[bI];
        // thực hiện so sánh từ khóa đươc nhập với ô trong bảng ;
        if (paramObject.firstName.toLowerCase() === bUserObject.firstname.toLowerCase() ||
          paramObject.lastName.toLowerCase() === bUserObject.lastname.toLowerCase()
        ) {
          //  thêm đối tượng vào mảng mới 
          vUserNew.push(bUserObject)
        }
      }
    }
    return vUserNew;
  }

  /**
   * Hàm load data vào table
   * Input: mảng users
   * Output: table có dữ liệu
   */
  function fillDataTableUser(paramObjectUser) {
    var vUserTable = $('#table-users');
    for (var bI = 0; bI < paramObjectUser.length; bI++) {
      var bNewRow = $('<tr/>').appendTo(vUserTable);
      var bId = $('<td/>', {
        html: paramObjectUser[bI].id
      }).appendTo(bNewRow);

      var vFirstName = $('<td/>', {
        html: paramObjectUser[bI].firstname
      }).appendTo(bNewRow);

      var vLastName = $('<td/>', {
        html: paramObjectUser[bI].lastname
      }).appendTo(bNewRow);

      var vCountry = $('<td/>', {
        html: paramObjectUser[bI].country
      }).appendTo(bNewRow);

      var vSubject = $('<td/>', {
        html: paramObjectUser[bI].subject
      }).appendTo(bNewRow);

      var vCustomerType = $('<td/>', {
        html: paramObjectUser[bI].customerType
      }).appendTo(bNewRow);

      var vRegisterStatus = $('<td/>', {
        html: paramObjectUser[bI].registerStatus
      }).appendTo(bNewRow);

      var vAction = $('<td/>').appendTo(bNewRow);
      var vDetailButon = $("<button/>", {
        text: "Chi tiết"
      }).addClass("btn btn-primary")
        .click(onChiTiet)
        .appendTo(vAction);
    }
  }

</script>

</html>
​